<style>
  .controls {
    display: inline-block;
  }

  /* Boites types causes */
  .dropzone_ishi {
    width: 104px;
    height: 64px;
    text-align:center;
    padding-top: 20px;
    position: absolute;
    border: 2px solid #fd4e20;
    border-radius: 5px;
  }
  .dropzone_ishi_txt {
    width: 104px;
    height: 64px;
    text-align:center;
    padding-top: 20px;
    position: absolute;
    background-color: #ddd;
    border: 2px solid #fd4e20;
    border-radius: 5px;
    box-shadow: 2px 2px 4px rgba(0, 0, 0, 0.4);
  }

  /* Boite effet */
  .cadre_ishi {
    padding: 5px;
    text-align:center;
    border: 3px solid #fd4e20;
    border-radius: 5px;
    box-shadow: 1px 1px 4px rgba(0, 0, 0, 0.4);
    width:146px;
    min-height:66px;max-height:141px;
    font:10pt Calibri;
    overflow: hidden;
  }
  .cadre_ishi:hover {max-height:none; z-index: 500;}

  /* Boites causes */
  .dzdrag_ishi {
    position: absolute;
    min-height: 44px;
    max-height: 44px;
    padding: 2px 22px 2px 2px;
    color: #434345;
    text-align: left;
    overflow: hidden;
    text-overflow: ellipsis;
    background-color: #ddd;
    border: 1px solid #bbb;
    border-radius: 5px;
    box-shadow: 1px 1px 4px rgba(0, 0, 0, 0.4);
    z-index: normal;
  }
  .dzdrag_ishi:hover {
    z-index: 500;
    max-height: none;
  }

  [draggable=true]{
      cursor: move;
  }
  [draggable=true]:hover{
      box-shadow:0 0 5px green;
  }

  [dropzone]:hover{
      box-shadow:0 0 5px red;
  }

  /* Cadre général ishi */
  .ishijs {
    border: black solid 5px;
    border: 1px solid #c6d0d5;
    border-radius: 3px;
    box-shadow: rgba(0, 0, 0, 0.1) 0px 2px 5px;
  }

  .form_ishikawa {
    width: 450px;
  }

  .ishijs_all {
    position: relative;
    font-size: 11px;
    padding: 0px;
    margin: 0px;
  }
  .ishikawa_pos {
    top: 0px;
    left: 0px;
  }

  .ishikawa_pos1 {
    position: relative;
  }
  .ishikawa_pos2 {
    position: absolute;
    background-color: #00F;
  }

  /* Icones delete et edit cause */
  .ishi_delc {
    width: 12px; height: 12px;
    position: absolute;
    top: 2px;
    right: 2px;
    cursor: pointer;
    font-size: 10px;
    padding-left: 1px;
  }
  .ishi_delc:hover { background: #fff }
  .ishi_editc {
    width: 12px; height: 12px;
    position: absolute;
    top: 18px;
    right: 2px;
    cursor: pointer;
    font-size: 10px;
    padding-left: 1px;
  }
  .ishi_editc:hover { background: #fff }

  /* Icones zoom Ishikawa */
  .ishi_zoom_pm {
    width: 22px; height: 22px;
    border: 1px solid #aaa;
    border-radius: 3px;
    position: absolute;
    cursor: pointer;
    padding: 0;
    box-shadow: 1px 1px 2px rgba(0, 0, 0, 0.4);
    font-size: 16px;
    padding-left: 2px;
  }
  .ishi_zoom_p {
    /*background: url(../../images/icones/22/zoom_p.png) center center no-repeat;*/
    left: 2px;
    top: 2px;
  }
  .ishi_zoom_m {
    /*background: url(../../images/icones/22/zoom_m.png) center center no-repeat;*/
    left: 2px;
    top: 32px;
  }
  .ishi_zoom_p:active {
    /*background: url(../../images/icones/22/zoom_p_b.png) center center no-repeat;*/
    border: 1px solid #2874a4;
  }
  .ishi_zoom_m:active {
    /*background: url(../../images/icones/22/zoom_m_b.png) center center no-repeat;*/
    border: 1px solid #2874a4;
  }

  .ishi_zoom_pm:hover {
    border: 1px solid #2874a4;
  }
  .ishi_zoom_pm:active {
    box-shadow: -1px -1px 2px rgba(0, 0, 0, 0.4);
  }

  /* Options Ishikawa (causes à afficher) */
  span.ishi_bs {
    font-size: 10px;
    position: absolute;
    width: 220px;
    text-align: right;
  }
  input.ishi_bs {
    /*position: absolute;
    right: 0px;*/
    font-size: 10px;
    transform: scale(0.8);
  }

  /* Aide de l'Ishikawa */
  .ishi_b_aide {
    /*width: 22px; height: 22px;
    position: absolute;*/
    cursor: help;
    /*padding: 0;
    border: 1px solid #aaa;
    border-radius: 3px;
    box-shadow: 1px 1px 2px rgba(0, 0, 0, 0.4);*/
    /*background: url(../../images/icones/22/aide_b.png) center center no-repeat;*/
    left: 2px;
    top: 62px;
  }
  .ishi_b_aide:hover, .ishi_b_aide:active { border: 1px solid #2874a4; }  /*#2874a4; }*/

  .ishi_aide {
    position: absolute;
    left: 30px;
    top: 60px;
    width: 250px;
    padding: 10px;
    border: 1px solid #2874a4;
    border-radius: 5px;
    box-shadow: 2px 2px 4px rgba(0, 0, 0, 0.5);
    background: #eee;
    color: #000;
    z-index: 101;
    visibility: hidden;
  }

  .drop-hover { border-color: #F00; }
  .ui-state-highlight { border-color: #FFFF00; }

  .ishikawa_columns {
    padding-left: 0px;
    margin-left: 15px;
  }
</style>

<div class="row">
  <div class="col-md-12 ishikawa_columns">
    <div style='padding-top: 0px;'>
      <div class='iskhikawa_zone' ishikawa_id='<%= @tools_ishikawa.id %>'
           ishi_fct_datas='<%= tools_ishikawa_js_tree_data_path %>'
           ishi_fct_drag='<%= tools_ishikawa_drag_cause_path %>'
           ishi_icon_del='<%= fa_icon_delete %>'
           ishi_fct_del='<%= tools_cause_path("id_de_la_cause") %>'
           ishi_icon_edit='<%= fa_icon_edit %>'
           ishi_fct_edit='<%= edit_tools_cause_path("id_de_la_cause") %>'
           ishi_icon_add='<%= fa_icon_add %>'
           ishi_fct_add='<%= new_tools_cause_path %>'
           ishi_icon_zp='<%= fa_icon_zoom_p %>'
           ishi_icon_zm='<%= fa_icon_zoom_m %>'
           ishi_fct_zp='<%= tools_ishikawa_zoom_path %>'
           ishi_fct_opt='<%= tools_ishikawa_update_option_path %>'
           ishi_icon_help='<%= fa_icon_help %>'
           ishi_fct_help='',
           ishi_show_buttons='<%= show_buttons %>'>
        <!-- ISHIKAWA HERE !!! -->


        <!-- <canvas id="canvas_iskhikawa" width="1000" height="700" style="border:1px solid #ccc"></canvas> -->
        <%
           zoom = @tools_ishikawa.options[:zoom] # 1.2 # .25

           ishi_w = (800*zoom+50).to_i.to_s;
           ishi_h = (450*zoom+30).to_i.to_s;
        %>

        <div id="ishikawa_draw<%= @tools_ishikawa.id %>" style="display: inline-block;" save-image-fct='<%= tools_save_image_path %>'>
          <canvas class="ishijs ishikawa_pos ishikawa_pos1" id="IshikawaCanvasJs<%= @tools_ishikawa.id %>" width='<%=ishi_w%>' height='<%=ishi_h%>' >
          </canvas>

          <div class="ishikawa_pos ishikawa_pos2" id="IshikawaDivJs<%= @tools_ishikawa.id %>" width='<%=ishi_w%>' height='<%=ishi_h%>' >
          </div>
        </div>

      </div>
      <br>
    </div>

    <div id='ishi_div_img<%= @tools_ishikawa.id %>'>
      <%= image_tag "", {id: "ishi_image#{@tools_ishikawa.id}"} %>
    </div>
  </div>
</div>

<script>
  // function divHtmltoImageReplaceAndSave(zediv, zeimg, img) {
  //   var node = $(zediv)[0];

  //   domtoimage.toPng(node)
  //       .then(function (dataUrl) {
  //           //var img = new Image();

  //           // Affiche l'image et hide l'ishikawa
  //           var divimage = $(zeimg)[0];
  //       divimage.src = dataUrl;
  //       $(zediv).hide();

  //           console.log("Save image on server");
  //           // Save
  //       var file= dataURLtoBlob(dataUrl);
  //       var fd = new FormData();
  //       fd.append("image", file);
  //       fd.append("imgname", img);
  //       $.ajax({
  //            url: "save_image_from_data",
  //            type: "POST",
  //            //beforeSend: function(xhr) {xhr.setRequestHeader('X-CSRF-Token', $('meta[name="csrf-token"]').attr('content'));},
  //            data: fd,
  //            processData: false,
  //            contentType: false,
  //       });
  //       })
  //       .catch(function (error) {
  //           console.error('oops, something went wrong!', error);
  //       });
  // }
  function save_canvas_to_png(div_canvas, image_name) {
    console.log("save_canvas_to_png");
    let dataURL = $("#IshikawaCanvasJs")[0].getContext('2d').canvas.toDataURL();

    let url = "<%= tools_save_canvas_to_png_path %>"
    let datas = {};
    datas = {'image': dataURL, 'id': '<%= @tools_ishikawa.id %>'}
    $.ajax({
      url: url,
      type: 'POST',
      data: datas,
      // dataType: 'json',
      beforeSend: function(xhr) {xhr.setRequestHeader('X-CSRF-Token', $('meta[name="csrf-token"]').attr('content'));},
      success: function(data) {
        console.log('OK!!!!');
      }
    });
  }

  // document.addEventListener("turbolinks:load", () => {
  //   // import html2canvas from 'html2canvas';
  //   setTimeout(function(){
  //     save_canvas_to_png("#IshikawaCanvasJs");

  //     // V2
  //     // html2canvas(document.querySelector("#iskhikawa_zone")).then(canvas => {
  //     //     document.body.appendChild(canvas)
  //     // });
  //   }, 3000)
  // });
</script>
